// Stitching ; UVa 10711

#include <iostream>
#include <math.h>

int N, n, m;

#define TMAX 30
#define SQR(x) ((x)*(x))
#define MIN(a,b) ((a) < (b) ? (a) : (b))

double X0[TMAX];
double Y0[TMAX];
double X1[TMAX];
double Y1[TMAX];
double Z1;
double aire0[TMAX][TMAX], aire1[TMAX][TMAX];

double cote(double x1, double y1, double z1, double x2, double y2, double z2)
{
  return sqrt(SQR(x2-x1)+SQR(y2-y1)+SQR(z2-z1));
}

double heron(double a, double b, double c) {
  const double p = (a+b+c)/2.0;
	
  return sqrt(p*(p-a)*(p-b)*(p-c));
}

double aire(double x1, double y1, double z1, 
	    double x2, double y2, double z2,
	    double x3, double y3, double z3) {
  double a = cote(x1, y1, z1, x2, y2, z2);
  double b = cote(x2, y2, z2, x3, y3, z3);
  double c = cote(x3, y3, z3, x1, y1, z1);
	
  return heron(a,b,c);
}
	
void aires() {
  for(int i = 0 ; i < m; i++) {
    for(int j = 0; j < n; j++) {
      aire0[i][j] = aire(X0[i], Y0[i], 0.0, X0[(i+m-1)%m],
			 Y0[(i+m-1)%m], 0.0, X1[j], Y1[j], Z1); 

      aire1[i][j] = aire(X0[i], Y0[i], 0.0, X1[j], Y1[j], Z1,
			 X1[(j+n-1)%n], Y1[(j+n-1)%n], Z1);

    }
  }
}

double aire_min() {
  int i0, j0;
  double aire_min_depuis_i0_j0;
  double aire_min_de_i0_j0_a_i_j[TMAX][TMAX];
		
  aire_min_depuis_i0_j0 = -1.0; 
  for(i0 = 0; i0 < m; i0++) {
    for(j0 = 0; j0 < n; j0++) {
      // position de dpart = (i0, j0)
      aire_min_de_i0_j0_a_i_j[0][0] = 0.0;
			
      // Programmation dynamique
      for(int i = 0; i <= m; i++) {
	for(int j = 0; j <= n; j++) {
	  if (i > 0) {
	    aire_min_de_i0_j0_a_i_j[i][j] = 
	      aire_min_de_i0_j0_a_i_j[i-1][j] + aire0[(i0+i)%m][(j0+j)%n];
	    if (j > 0) {
	      aire_min_de_i0_j0_a_i_j[i][j] =
		MIN(aire_min_de_i0_j0_a_i_j[i][j],
		    aire_min_de_i0_j0_a_i_j[i][j-1] 
		    + aire1[(i0+i)%m][(j0+j)%n]);
	    }
	  } else {
	    if (j > 0) {
	      aire_min_de_i0_j0_a_i_j[i][j] = 
		aire_min_de_i0_j0_a_i_j[i][j-1] 
		+ aire1[(i0+i)%m][(j0+j)%n];
	    }
	  }
	}
      }

      if ((aire_min_depuis_i0_j0 > aire_min_de_i0_j0_a_i_j[m][n]) ||
	  (aire_min_depuis_i0_j0 < 0.))
	aire_min_depuis_i0_j0 = aire_min_de_i0_j0_a_i_j[m][n];
    }
  }	
  return aire_min_depuis_i0_j0;
}

int main (){
  std::cin >> N;
	
  for(;N > 0; N--) {
    // lecture des entres
    std::cin >> m >> n >> Z1;
    for(int i = 0; i < m; i++) 
      std::cin >> X0[i] >> Y0[i];
    X0[m] = X0[0];
    Y0[m] = Y0[0];
		
    for(int j = 0; j < n; j++) 
      std::cin >> X1[j] >> Y1[j];
    X1[n] = X1[0];
    Y1[n] = Y1[0];
				
    aires();
    std::cout << aire_min() << "\n";
  }
	
  // fini
  return 0;
}
